//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3FCB6C8702B9.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3FCB6C8702B9.cm

//## begin module%3FCB6C8702B9.cp preserve=no
//## end module%3FCB6C8702B9.cp

//## Module: ParamLinkList%3FCB6C8702B9; Package specification
//## Subsystem: XSModel::Parameter%367691A8CEA0
//	/local/data/verisB/dorman/Xspec/src/XSModel/Parameter
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Parameter/ParamLinkList.h

#ifndef PARAMLINKLIST_H
#define PARAMLINKLIST_H 1

//## begin module%3FCB6C8702B9.additionalIncludes preserve=no
//## end module%3FCB6C8702B9.additionalIncludes

//## begin module%3FCB6C8702B9.includes preserve=yes
class ResponseParam;
#include <map>
//## end module%3FCB6C8702B9.includes


class ParameterLink;
class Parameter;

//## begin module%3FCB6C8702B9.declarations preserve=no
//## end module%3FCB6C8702B9.declarations

//## begin module%3FCB6C8702B9.additionalDeclarations preserve=yes
//## end module%3FCB6C8702B9.additionalDeclarations


//## begin ParamLinkList%38EB50F34EE8.preface preserve=yes
//## end ParamLinkList%38EB50F34EE8.preface

//## Class: ParamLinkList%38EB50F34EE8
//## Category: XSModel::Parameter%36349D8902D7
//## Subsystem: XSModel::Parameter%367691A8CEA0
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3FCB72A1013F;ParameterLink { -> F}

class ParamLinkList 
{
  //## begin ParamLinkList%38EB50F34EE8.initialDeclarations preserve=yes
  //## end ParamLinkList%38EB50F34EE8.initialDeclarations

  public:
    //## Destructor (generated)
      ~ParamLinkList();


    //## Other Operations (specified)
      //## Operation: unlink%38EB50F3F360;           C++
      //	Additional Public Declarations
      void unlink (Parameter* p);

      //## Operation: Instance%38EB50F3F361;         C++
      static ParamLinkList* Instance ();

      //## Operation: setCompute%3CA097A40285
      void setCompute (const Parameter* param, bool flag) const;

      //## Operation: removeDependentParameterLinks%3F09EC220134
      void removeDependentParameterLinks (Parameter* p);

      //## Operation: updateResponseParamLinkers%49DA5F3902DE
      //	Tell all ResponseParams which link to respPar that resp
      //	Par has changed.
      void updateResponseParamLinkers (const ResponseParam* respPar) const;

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Parameter::linkList%38ECEA96B3E0
      //## Role: ParamLinkList::linkList%38ECEA96B4F8
      //## Qualifier: key%391712D04948; Parameter*
      const std::map<Parameter*,ParameterLink*>& linkList () const;
      const ParameterLink* linkList (Parameter* key) const;
      void linkList (Parameter* key, ParameterLink* value);

    // Additional Public Declarations
      //## begin ParamLinkList%38EB50F34EE8.public preserve=yes
      //## end ParamLinkList%38EB50F34EE8.public

  protected:
    //## Constructors (generated)
      ParamLinkList();

    // Additional Protected Declarations
      //## begin ParamLinkList%38EB50F34EE8.protected preserve=yes
      //## end ParamLinkList%38EB50F34EE8.protected

  private:
    // Additional Private Declarations
      //## begin ParamLinkList%38EB50F34EE8.private preserve=yes
      //## end ParamLinkList%38EB50F34EE8.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: instance%38EB50F3F362
      //## begin ParamLinkList::instance%38EB50F3F362.attr preserve=no  implementation: static ParamLinkList* {U} 
      static ParamLinkList* s_instance;
      //## end ParamLinkList::instance%38EB50F3F362.attr

    // Data Members for Associations

      //## Association: XSModel::Parameter::linkList%38ECEA96B3E0
      //## begin ParamLinkList::linkList%38ECEA96B4F8.role preserve=no  public: Parameter {1..n -> 1..nRFHN}
      std::map<Parameter*,ParameterLink*> m_linkList;
      //## end ParamLinkList::linkList%38ECEA96B4F8.role

    // Additional Implementation Declarations
      //## begin ParamLinkList%38EB50F34EE8.implementation preserve=yes
      //## end ParamLinkList%38EB50F34EE8.implementation

};

//## begin ParamLinkList%38EB50F34EE8.postscript preserve=yes
//## end ParamLinkList%38EB50F34EE8.postscript

// Class ParamLinkList 

//## Get and Set Operations for Associations (inline)

inline const std::map<Parameter*,ParameterLink*>& ParamLinkList::linkList () const
{
  //## begin ParamLinkList::linkList%38ECEA96B4F8.get preserve=no
  return m_linkList;
  //## end ParamLinkList::linkList%38ECEA96B4F8.get
}

inline const ParameterLink* ParamLinkList::linkList (Parameter* key) const
{
  //## begin ParamLinkList::linkList%38ECEA96B4F8.qualget preserve=yes
  std::map<Parameter*,ParameterLink*>::const_iterator f(m_linkList.find(key));
  return (f != m_linkList.end() ?  f->second : 0 );
  //## end ParamLinkList::linkList%38ECEA96B4F8.qualget
}

inline void ParamLinkList::linkList (Parameter* key, ParameterLink* value)
{
  //## begin ParamLinkList::linkList%38ECEA96B4F8.qualset preserve=no
  m_linkList[key] = value;
  //## end ParamLinkList::linkList%38ECEA96B4F8.qualset
}

//## begin module%3FCB6C8702B9.epilog preserve=yes
//## end module%3FCB6C8702B9.epilog


#endif
